function [WA] = getweight(img,space)
ss=size(img);

WA=ones(ss*2+1);

[dy,dx,dz]=gradient(img,space(1),space(2),space(3));
% niftiwrite(dx,"dx");
% niftiwrite(dy,"dy");
% niftiwrite(dz,"dz");

WA = weight3(WA, dx, dy, dz, space);
WA = weight2(WA, dx, dy, dz, space);

[vq, WA] = weight0(img, WA,space );
% niftiwrite(WA,"WA3");

WA = weight1(WA, vq, space);
end
function WA = weight3(WA, dx, dy, dz, space)
WA(2:2:end-1,2:2:end-1,2:2:end-1)=sqrt(1+dx.^2+dy.^2+dz.^2)*space(1)*space(2)*space(3);
% niftiwrite(WA,"WA1");
end

function [WA] = weight2(WA, dx, dy, dz, space)

aa=sqrt(1+dx.^2)*space(1);
saa=convn(aa,reshape([1,1],[2,1,1]),"valid");
saa=aa(1:end-1,:,:)./saa;
% assert(all(saa>=0&saa<=1,"all"));
WA(3:2:end-2,2:2:end-1,2:2:end-1)=sqrt(1+((1-saa).*dy(1:end-1,:,:)+saa.*dy(2:end,:,:)).^2+((1-saa).*dz(1:end-1,:,:)+saa.*dz(2:end,:,:)).^2)*space(2)*space(3);
WA(end,2:2:end-1,2:2:end-1)=sqrt(1+(dy(end,:,:)).^2+(dz(end,:,:)).^2)*space(2)*space(3);
WA(1,2:2:end-1,2:2:end-1)=sqrt(1+(dy(1,:,:)).^2+(dz(1,:,:)).^2)*space(2)*space(3);

aa=sqrt(1+dy.^2)*space(2);
saa=convn(aa,reshape([1,1],[1,2,1]),"valid");
saa=aa(:,1:end-1,:)./saa;
% assert(all(saa>=0&saa<=1,"all"));
WA(2:2:end-1,3:2:end-2,2:2:end-1)=sqrt(1+((1-saa).*dx(:,1:end-1,:)+saa.*dx(:,2:end,:)).^2+((1-saa).*dz(:,1:end-1,:)+saa.*dz(:,2:end,:)).^2)*space(1)*space(3);
WA(2:2:end-1,end,2:2:end-1)=sqrt(1+(dx(:,end,:)).^2+(dz(:,end,:)).^2)*space(1)*space(3);
WA(2:2:end-1,1,2:2:end-1)=sqrt(1+(dx(:,1,:)).^2+(dz(:,1,:)).^2)*space(1)*space(3);

aa=sqrt(1+dz.^2)*space(3);
saa=convn(aa,reshape([1,1],[1,1,2]),"valid");
saa=aa(:,:,1:end-1)./saa;
% assert(all(saa>=0&saa<=1,"all"));
WA(2:2:end-1,2:2:end-1,3:2:end-2)=sqrt(1+((1-saa).*dy(:,:,1:end-1)+saa.*dy(:,:,2:end)).^2+((1-saa).*dx(:,:,1:end-1)+saa.*dx(:,:,2:end)).^2)*space(1)*space(2);
WA(2:2:end-1,2:2:end-1,end)=sqrt(1+(dy(:,:,end)).^2+(dx(:,:,end)).^2)*space(1)*space(2);
WA(2:2:end-1,2:2:end-1,1)=sqrt(1+(dy(:,:,1)).^2+(dx(:,:,1)).^2)*space(1)*space(2);
% niftiwrite(WA,"WA2");
end

function [vq, WA] = weight0(img, WA,space)
ss=size(img);
pimg=padarray(img,[1,1,1],"replicate","both");
[Xq,Yq,Zq]=meshgrid(((1:(ss(2)+1))+0.5)*space(2),((1:(ss(1)+1))+0.5)*space(1),((1:(ss(3)+1))+0.5)*space(3));
vq = interp3((1:(ss(2)+2))*space(2),((1:(ss(1)+2))*space(1))',(1:(ss(3)+2))*space(3),pimg,Xq,Yq,Zq);
WA(1:2:end,1:2:end,1:2:end)=vq;
end

function WA = weight1(WA, vq, space)
WA(2:2:end-1,1:2:end,1:2:end)=sqrt(convn(vq,reshape([1 -1],[2,1]),"valid").^2+space(1)^2);
WA(1:2:end,2:2:end-1,1:2:end)=sqrt(convn(vq,reshape([1 -1],[1,2]),"valid").^2+space(2)^2);
WA(1:2:end,1:2:end,2:2:end-1)=sqrt(convn(vq,reshape([1 -1],[1,1,2]),"valid").^2+space(3)^2);
end

